/*------------------------------------------------------------------------------
 * MDK Middleware - Component ::USB:Device
 * Copyright (c) 2004-2019 Arm Limited (or its affiliates). All rights reserved.
 *------------------------------------------------------------------------------
 * Name:    HID.c
 * Purpose: USB Device - Human Interface Device example
 *----------------------------------------------------------------------------*/

#include "rl_usb.h"                     // Keil.MDK-Pro::USB:CORE

#include "Board_Buttons.h"              // ::Board Support:Buttons

/* Main stack size must be multiple of 8 Bytes */
#define APP_MAIN_STK_SZ (1024U)
static uint64_t app_main_stk[APP_MAIN_STK_SZ / 8];
const osThreadAttr_t app_main_attr = {
  .stack_mem  = &app_main_stk[0],
  .stack_size = sizeof(app_main_stk)
};

__NO_RETURN void app_main (void *arg);

/*------------------------------------------------------------------------------
 *        Application
 *----------------------------------------------------------------------------*/
__NO_RETURN void app_main (void *arg) {
  uint8_t but;
  uint8_t buf[2] = { 0, 0 };

  (void)arg;

  USBD_Initialize         (0U);         /* USB Device 0 Initialization        */
  USBD_Connect            (0U);         /* USB Device 0 Connect               */

  USBD_Initialize         (1U);         /* USB Device 1 Initialization        */
  USBD_Connect            (1U);         /* USB Device 1 Connect               */

  while (1) {                           /* Loop forever                       */
    but = (uint8_t)(Buttons_GetState ());
    if ((but ^ buf[0]) & 1U) {
      buf[0] = but & 1U;
      USBD_HID_GetReportTrigger(0U, 0U, &buf[0], 1U);
    }
    if ((but ^ buf[1]) & 1) {
      buf[1] = but & 1;
      USBD_HID_GetReportTrigger(1U, 0U, &buf[1], 1U);
    }
    osDelay(100U);                       /* 100 ms delay for sampling buttons  */
  }
}
